import static org.junit.Assert.assertEquals;

import java.io.ByteArrayOutputStream;
import java.io.PrintStream;
import java.io.StringBufferInputStream;

import org.junit.Test;

@SuppressWarnings("deprecation")
public class AnalyzerTest {

	private void test(String in, String expectedOut){
		System.setIn(new StringBufferInputStream(in));
		ByteArrayOutputStream out = new ByteArrayOutputStream();
		System.setOut(new PrintStream(out));
		Analyzer.main(new String[0]);
		assertEquals(expectedOut, out.toString());
	}

	@Test
	public void example() {
		test(
				"begin declare x use y declare y begin use x declare" + 
				" x use x declare x use x declare y end use x end",

				"begin\n" +
				"  declare x {declaration 1}\n" +
				"  use y {illegal undeclared use}\n" +
				"  declare y {declaration 2}\n" +
				"  begin\n" +
				"    use x {references declaration 1}\n" +
				"    declare x {declaration 3}\n" +
				"    use x {references declaration 3}\n" +
				"    declare x {illegal redeclaration}\n" +
				"    use x {references declaration 3}\n" +
				"    declare y {declaration 4}\n" +
				"  end\n" +
				"  use x {references declaration 1}\n" +
				"end\n"
			);
	}
}
